CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
; Versin 5

PON_DEL_REVES:
; Condicin de llamada: 
;       en DX:SI la direccin lgica de la cadena
;       en CX el nmero de palabras de la cadena (no puede ser 0)
; Condicin de salida: la cadena original ha sido puesta del revs, 
;				en DX:SI
; Comentario: Para acceder a una palabra se usa [SI] y  para la
;             homloga del extremo opuesto [DI]

        PUSH    DS              ; guarda contexto y direccin de cadena
	PUSH	ES
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	MOV	DS,DX
	MOV	ES,DX
	CLD			; modo incremental; Inicia segmento:
; Inicia ndice para acceder a palabra opuesta (DI <-- SI+(CX x 2)-2:
	MOV	DI,CX
	ADD	DI,DI		; o SHL  DI,1
	SUB	DI,2
	ADD	DI,SI
; Divide por 2 el nmero de palabras (factor de iteracin del bucle):
	SHR	CX,1
; Es una cadena de slo una palabra?
	JCXZ	CADENA_SOLO_ES_UNA_PALABRA
; No. Guarda el resto (en el acarreo):
	PUSHF

; Toma palabra y apunta a la siguiente:
OTRA_PALABRA:
	LODSW
; Ponerla del revs:
	CALL	PON_DEL_REVES_PALABRA_EN_AX
; Ponerla en el extremo homlogo y tomar la palabra de ese extremo:
	XCHG	[DI],AX
; Ponerla del revs...:
	CALL	PON_DEL_REVES_PALABRA_EN_AX
; ...y dejarla en el otro extremo homlogo y...
	MOV	[SI-2],AX
; ...apuntar al extremo homlogo anterior:
        SUB     DI,2            ; y que DI apunte al homlogo previo
; Quedan palabras?
	LOOP	OTRA_PALABRA
; En principio no, comprobar entonces si queda una ltima:
; Recuperar el resto de la divisin por dos:
	POPF
; hubo resto?
	JNC	YA_ESTA 
; S: ponerla del revs:
QUEDA_UNA_PALABRA:
CADENA_SOLO_ES_UNA_PALABRA:
; Como SI y DI tiene el mismo valor, se puede usar LODSW y STOSW:
	LODSW
	CALL	PON_DEL_REVES_PALABRA_EN_AX
	STOSW
YA_ESTA:	
        POP     DI              ; restaurar contexto y direccin cadena
	POP	SI
	POP	DX
	POP	CX
	POP	ES
	POP	DS
	RET

PON_DEL_REVES_PALABRA_EN_AX:
	PUSH	CX		; guarda contexto del bucle externo
	MOV	CX,16
SIGUIENTE_BIT:
	RCL	AX,1
	RCR	DX,1
	LOOP	SIGUIENTE_BIT
	MOV	AX,DX
	POP	CX
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
