COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=                   POR EL MTODO DE LA BURBUJA                    =
=                            Versin 10                            =
====================================================================

Este procedimiento ordena, de menor a mayor, una lista de 10 datos tipo octeto
almacenados a partir de la direccin lgica 38F6:2000h

CONDICIN DE ENTRADA:    Ninguna
CONDICIN DE SALIDA:     Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX y SI y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones en el bucle que hace una pasada por
	todas las parejas de datos de la lista.
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
*


SEGMENTO	EQU	38F6h
LISTA		EQU	2000h
NUMERO_DAT	EQU	10
AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
		MOV	BX,SEGMENTO     
		MOV	DS,BX
                MOV     SI, NUMERO_DAT ;SI indica el nmero de parejas + 1

;iniciacin de variables:
OTRA_PASADA:    DEC     SI                  ; una pareja menos
                MOV     AL,NO               ; CAMBIO <-- NO     
                MOV     CX,SI               ; CONTADOR <-- nmero de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,OFFSET  LISTA
; Evala pareja:
SIGUIENTE_PAREJA:	
		MOV	DX,[BX]		

; estn ordenados?
		CMP	DL,DH	
		JBE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	DL,DH	
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          INC     BX       

; quedan ms parejas? 
                LOOP    SIGUIENTE_PAREJA       ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
		DEC	AL		
                JNZ     OTRA_PASADA            ; s: iterar un nuevo barrido
                RET                            ; no: lista ordenada, retornar
