COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=               POR EL MTODO DE LA BURBUJA (versin 2b)           =
=                                                                  =
====================================================================

Este procedimiento ordena, de mayor a menor, una lista de datos tipo palabra
sin signo, que comienza en cualquier parte.

CONDICIN DE ENTRADA:    
Se deben pasar por registro los siguientes parmetros:
BX:     parte de desplazamiento de la direccin lgica de inicio
DX:     segmento de la direccin lgica de inicio de la lista de datos
SI:     Nmero de  datos de la lista

CONDICIN DE SALIDA: 	 Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX y SI y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones en el bucle que hace una pasada por
	todas las parejas de datos de la lista.
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
DI:     Variable para actualizar el valor del segmento en la paginacin.
BP:	Variable  que retiene el inicio de la lista.
*


AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
		MOV	CS:SEGMENTO,DX
                MOV     BP,BX           ; guardar la direccin de inicio
;iniciacin de variables:
OTRA_PASADA:
                DEC     SI                  ; una pareja menos
                MOV     AL,NO               ; CAMBIO <-- NO     
                MOV     CX,SI               ; CONTADOR<-- nmero de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,BP               ; ya no se hace referencia 
                MOV     DS,CS:SEGMENTO      ; explicita al inicio de la lista
				
; Evala pareja:
SIGUIENTE_PAREJA:	
                MOV     DX,[BX]  

; estn ordenados?
		CMP	DX,[BX+2]	
		JAE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	DX,[BX+2]	
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          ADD     BX,2     
; hay que segmentar?
		JNC	MISMO_SEGMENTO
;       s:
		MOV	DI,DS
		ADD	DI,1000H
		MOV	DS,DI

MISMO_SEGMENTO:
; quedan ms parejas? 
                LOOP    SIGUIENTE_PAREJA     ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
                DEC     AL       
                JNZ     OTRA_PASADA           ; si: iterar un nuevo barrido
                RET                           : no: lista ordenada, retornar
                EVEN
SEGMENTO	DW	?

