COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=               POR EL MTODO DE LA BURBUJA (versin 2c)           =
=                                                                  =
====================================================================

Este procedimiento ordena, de mayor a menor, una lista de cualquier tamao
de datos tipo palabra sin signo, que comienza en cualquier parte.

CONDICIN DE ENTRADA:    
Se deben pasar por registro los siguientes parmetros:
BX:     Parte de desplazamiento de la direccin lgica de inicio
DX:     Segmento de la direccin lgica de inicio de la lista de datos
CX:     Palabra baja del tamao de la lista
SI:     Palabra alta del tamao de la lista

CONDICIN DE SALIDA: 	 Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX, DX, SI, DI y BP y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn  intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones, parte baja, en el bucle que hace una pasada
        por todas las parejas de datos de la lista.
BP:     Variable de gestin de bucle, parte alta
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
DI:     Variable para actualizar el valor del segmento en la paginacin.

TAMANYO_LISTA: Variable que indica las parejas que quedan por ordenar
INICIO_S: Variable que retiene el inicio de la lista (segmento).
INICIO_D: Variable que retiene el inicio de la lista (desplazamiento)
*


AFIRMATIVO	EQU	0 
NO		EQU	1

;iniciacin de variables generales:
ORDENA_LISTA:
                MOV     CS:INICIO_S,DX  ; guardar la direccin de inicio
		MOV	CS:INICIO_D,BX
                MOV     CS:TAMANYO_LISTA,CX  ;guarda tamao de la lista
		MOV	CS:TAMANYO_LISTA+2,SI
;iniciacin de variables:
OTRA_PASADA:
		SUB	CS:TAMANYO_LISTA,1 ; una pareja menos
		SBB	CS:TAMANYO_LISTA+2,0
                CMP     CS:TAMANYO_LISTA,0
                JE      VER_SI_QUEDA_LISTA
CONTINUA:       MOV     AL,NO                 ; CAMBIO <-- NO
                MOV     BP,TAMANYO_LISTA+2    ; CONTADOR <-- nmero de parejas 
		MOV	CX,TAMANYO_LISTA	  
;iniciacin de DS:BX para que apunte al inicio de la LISTA:                             LDS     BX,CS:INICIO_LISTA
		INC	BP
SIGUIENTE:	DEC	BP		
; Evala pareja:
SIGUIENTE_PAREJA:	
                MOV     DX,[BX]  
; estn ordenados?
		CMP	DL,DH	
		JAE	SIGUE		
; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	DL,DH	
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          INC     BX       
; hay que segmentar?
		JNZ	MISMO_SEGMENTO
;       s:
		MOV	DI,DS
		ADD	DI,1000H
		MOV	DS,DI
MISMO_SEGMENTO:
; quedan ms parejas? 
		LOOP	SIGUIENTE_PAREJA		
		CMP	BP,0
		JNE	SIGUIENTE
SALIDA_BUCLE:
; No: se ha hecho algn cambio?  
                DEC     AL       
                JNZ     OTRA_PASADA       ; si: iterar un nuevo barrido
                RET                       ; no: lista ordenada, retornar
VER_SI_QUEDA_LISTA:
		CMP	CS_TAMANYO_LISTA+2,0
		JNE	CONTINUA
		RET
                EVEN
TAMANYO_LISTA   DW      2 DUP(?)
INICIO_LISTA LABEL DWORD
INICIO_D	DW  	?
INICIO_S	DW 	?
