COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=              POR EL MTODO DE LA BURBUJA  (versin 3)            =
=                                                                  =
====================================================================
Este procedimiento ordena, de mayor a menor, una lista de  cualquier tamao,
de datos tipo octeto y que comienza en cualquier parte.

CONDICIN DE ENTRADA:    
Se deben pasar por pila los siguientes parmetros:
1:     segmento de la direccin lgica de inicio de la lista de datos
2:     parte de desplazamiento de la direccin lgica de inicio
3:     Tamao de la lista

CONDICIN DE SALIDA:     Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX y SI y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones en el bucle que hace una pasada por
	todas las parejas de datos de la lista.
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
DI:     Variable para actualizar el valor del segmento en la paginacin.
BP:	Variable  que retiene el inicio de la lista.
*

AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
                POP     CS:TEMPORAL1 ; tomar la direccin de retorno
                POP     CS:TEMPORAL2
                POP     SI
                POP     BX
                POP     CS:SEGMENTO
                PUSH    CS:TEMPORAL2 ;restaurar direccin de retorno
                PUSH    CS:TEMPORAL1
; MOV   CS:SEGMENTO,DX  esta instruccin ya no es precisa
;iniciacin de variables:
OTRA_PASADA:    DEC     SI                  ; una pareja menos
                MOV     AL,NO               ; CAMBIO <-- NO     
                MOV     CX,SI               ; CONTADOR <-- nmero de parejas

;iniciacin de DS y puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,BP            ; ya no se hace referencia explcita
                MOV     DS,CS:SEGMENTO   ; al inicio de la lista                         
; Evala pareja:
SIGUIENTE_PAREJA:	
		MOV	DX,[BX]		

; estn ordenados?
		CMP	DL,DH	
		JAE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
		XCHG	DL,DH	
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          INC     BX       
; hay que segmentar?
		JNZ	MISMO_SEGMENTO
;       s:
		MOV	DI,DS
		ADD	DI,1000H
		MOV	DS,DI

MISMO_SEGMENTO:
; quedan ms parejas?
                LOOP    SIGUIENTE_PAREJA      ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
		DEC	AL		
                JNZ     OTRA_PASADA           ; s: iterar un nuevo barrido
                RETF             ; RETF si se trata de un procedimiento lejano
		EVEN
SEGMENTO	DW	?
TEMPORAL1	DW	?
TEMPORAL2	DW	?
