COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=               POR EL MTODO DE LA BURBUJA (versin 4)            =
=                                                                  =
====================================================================

Este procedimiento ordena, en cualquier sentido, una lista de cualquier tamao,
de datos tipo octeto y que comienza en cualquier parte.

CONDICIN DE ENTRADA:    
Se deben pasar por registro los siguientes parmetros:
AH:     Indica sentido de ordenacin: 0 --> ascendente; no 0 --> descend.
BX:     parte de desplazamiento de la direccin lgica de inicio
DX:     segmento de la direccin lgica de inicio de la lista de datos
SI:     Tamao de la lista

CONDICIN DE SALIDA:     Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX, DX, SI,  DI, BP y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn  intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones en el bucle que hace una pasada por
	todas las parejas de datos de la lista.
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
DI:     Variable para actualizar el valor del segmento en la paginacin.
BP:	Variable  que retiene el inicio de la lista.
*

AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
		MOV	CS:SEGMENTO,DX
                MOV     BP,BX           ; guardar la direccin de inicio
;iniciacin de variables:
OTRA_PASADA:    DEC     SI                      ; una pareja menos
                MOV     AL,NO                   ; CAMBIO <-- NO     
                MOV     CX,SI                   ; CONTADOR <-- nmero  de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,BP             ; ya no se hace referencia explcita
                MOV DS,CS:SEGMENTO        ; al inicio de la lista                         
; Evala pareja:
SIGUIENTE_PAREJA:	
                MOV     DX,[BX]  

; estn ordenados?
                CMP     AH,0            ; en qu sentido?
		JE	ASCENDENTE
		CMP	DL,DH		; sentido descendente: mayor a menor
		JAE	SIGUE		

; NO: hay que intercambiarlos, e indicar que se ha hecho cambio:
INTERCAMBIA:    XCHG    DL,DH 
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:          INC     BX       
; hay que segmentar?
		JNZ	MISMO_SEGMENTO
;       s:
		MOV	DI,DS
		ADD	DI,1000H
		MOV	DS,DI

MISMO_SEGMENTO:
; quedan ms parejas? 
                LOOP    SIGUIENTE_PAREJA       ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
                DEC     AL       
                JNZ     OTRA_PASADA           ; si: iterar un nuevo barrido
                RET                           ; no: lista ordenada, retornar
ASCENDENTE:	
                CMP     DL,DH
                JBE     SIGUE
                JNBE    INTERCAMBIA     ; equivale a JMP SHORT INTERCAMBIA
		EVEN
SEGMENTO	DW	?
		
