COMMENT *
====================================================================
=                                                                  =
=              PROCEDIMIENTO DE ORDENACIN DE UNA LISTA            =
=               POR EL MTODO DE LA BURBUJA (versin 6)            =
=                                                                  =
====================================================================

Este procedimiento ordena, en cualquier sentido, una lista, que comienza en
cualquier parte, de datos tipo octeto con o sin signo.

CONDICIN DE ENTRADA:    
Se deben pasar por registro los siguientes parmetros:
AH:     AH0 Indica el sentido de ordenacin:
                0--> ascendente      1--> descend.
        AH7  Indica  el tipo de datos: 0--> sin signo, 1-->  con signo
BX:     parte de desplazamiento de la direccin lgica de inicio
DX:     segmento de la direccin lgica de inicio de la lista de datos
SI:     Tamao de la lista

CONDICIN DE SALIDA:     Ninguna
REGISTROS AFECTADOS:	 AX, BX, CX, DX, SI,  DI, BP y banderas

USO DE RECURSOS:
AL:     Variable que indica si se ha hecho o no algn intercambio:
        AL=0 indica que s
	AL=1 indica que no
BX:	Puntero para acceder a los datos de la lista.
CX:	Contador de iteraciones en el bucle que hace una pasada por
	todas las parejas de datos de la lista.
DX:     Variable para contener cada pareja de octetos (DL 1, DH 2) 
SI:     Variable que contiene el tamao de la lista -1, a cada pasada.
DI:     Variable para actualizar el valor del segmento en la paginacin.
BP:	Variable  que retiene el inicio de la lista.
*

AFIRMATIVO	EQU	0 
NO		EQU	1

ORDENA_LISTA:
		MOV	CS:CODIGO,DX
                MOV     BP,BX           ; guardar la direccin de inicio
;iniciacin de variables:
OTRA_PASADA:
                DEC     SI                  ; una pareja menos
                MOV     AL,NO               ; CAMBIO <-- NO     
                MOV     CX,SI               ; CONTADOR <-- nmero de parejas

;iniciacin del puntero BX para que apunte al inicio de la LISTA:
                MOV     BX,BP        ; ya no se hace referencia explcita
                MOV     DS:CS:SEGMENTO   ; al inicio de la lista                         
; Evala pareja:
SIGUIENTE_PAREJA:	
                MOV     DX,[BX]  
; estn ordenados?
;   en qu sentido?
		TEST	AH,00000001b	
		JZ	ASCENDENTE
;	 descendente:	
                CMP     DL,DH    
                PUSHF                   ; guarda  banderas para 
                                        ; que TEST no las  machaque
;        qu tipo de datos?
                TEST    AH,10000000b    ; tipo de datos?
		JZ	SIN_SIGNO_DESC
;	  Con signo:	
                POPF                    ; recupera banderas de CMP DL,DH
		JGE	SIGUE			
		JMP	SHORT	 INTERCAMBIA
;	  Sin signo:
SIN_SIGNO_DESC:
		POPF
                JAE     SIGUE            

; NO estn ordenados: 
;   hay que intercambiarlos, e indicar que ha hecho cambio:
INTERCAMBIA:    XCHG	DL,DH	
		MOV	[BX],DX
		SUB	AL,AL		; CAMBIO <-- SI

; preparar siguiente pareja:
SIGUE:	INC	BX		
; hay que segmentar?
		JNZ	MISMO_SEGMENTO
;       s:
		MOV	DI,DS
		ADD	DI,1000H
		MOV	DS,DI

MISMO_SEGMENTO:
; quedan ms parejas? 
                LOOP    SIGUIENTE_PAREJA        ; si: tomar siguiente pareja

; No: se ha hecho algn cambio?  
                DEC     AL       
                JNZ     OTRA_PASADA           ; si: iterar un nuevo barrido
                RET                           ; no: lista ordenada, retornar
ASCENDENTE:	
                CMP     DL,DH
;   qu tipo de datos?
		PUSHF
		TEST	AH,10000000b	
		JZ	SIN_SIGNO_ASC

;	  Con signo:
		POPF
		JLE	SIGUE			
		JMP	SHORT	 INTERCAMBIA

;	  Sin  signo:
SIN_SIGNO_ASC:
		POPF
                JBE     SIGUE                   ; sin signo
                JNBE    INTERCAMBIA

                EVEN
SEGMENTO	DW	? 

