CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
COMMENT +
*********************************************************************
*                                                                   *
*                   PROCEDIMIENTO BORRA_PANTALLA                    *
*                                                                   *
*********************************************************************

Descripcin: Permite borrar una pantalla de 25 filas por 80 columnas. Se pone
atributo de fondo negro y texto blanco. La memoria de vdeo est en el inicio del segmento B800h.
Condiciones de entrada: ninguna
Condiciones de salida: ninguna

Registros usados y afectados:
AX:     Como variable general, y para contener la palabra carcter/atributo de
        borrado.
ES:     Para el segmento de vdeo, B800h.
CX:     Como contador de iteraciones del bucle.
DI:     Como puntero ndice para direccionar los elementos de la pantalla.
Registro de estado
+
 
ESPACIO         EQU     20h     ; sera equivalente poner: ESPACIO  EQU  ' '
ATRIBUTO	EQU	07h
PATRON_DE_BORRADO	EQU	(ATRIBUTO SHL 8)+ESPACIO
SEGMENTO_DE_VIDEO	EQU	0B800h
FILAS		EQU	25
COLUMNAS	EQU	80


BORRA _PANTALLA:
; inicia el segmento de datos extra con el segmento de la pantalla:
	MOV	AX,SEGMENTO_DE_VIDEO
	MOV	ES,AX
; inicia las variables:
        CLD                     ; modo incremental de los ndices
	MOV	AX,PATRON_DE_BORRADO
	SUB	DI,DI
; iniciar el contador de iteraciones  del bucle:
	MOV	CX,FILAS*COLUMNAS
; borrar la pantalla:
        REP STOSW
	RET

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
