CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
TRASLADA_BLOQUE:                ; Versin 5b
; Descripcin: Rutina para el traslado intrasegmento de un bloque.
; Condicin de entrada:
; 	AX: segmento de origen y destino
;	SI: inicio del bloque
;	DI: inicio del destino
;       CX: tamao del bloque a trasladar (no se admite tamao 0, 
;           puesto que 0 significa tamao  64 kilo-octetos)


	MOV	DS,AX		; inicia segmentos: datos para la fuente
	MOV	ES,AX		; y extra para el destino
; Comprobar si el destino est entre los lmites del bloque:
	CMP	SI,DI
	JAE	RECORRIDO_ASCENDENTE2
	ADD	SI,CX		; SI <-- final del bloque
	CMP	SI,DI
	JBE	RECORRIDO_ASCENDENTE
RECORRIDO_DESCENDENTE:
	ADD	DI,CX		; DI <-- final del destino
	DEC	SI		; corrige los punteros
	DEC	DI
        STD                     ; modo decremental de los ndices
	JMP	SHORT TRASLADA
RECORRIDO_ASCENDENTE:
	SUB	SI,CX		; restaura SI con el inicio del bloque
RECORRIDO_ASCENDENTE2:
        CLD                     ; modo incremental de los ndices
TRASLADA:
        CMP     CX,1  ; por si el bloque tiene tamao de slo 1
	JE	TERMINA
; Comprobar si  la direccin de inicio es par (palabras alineadas):
	TEST	SI,1b
	JZ	BLOQUE_ALINEADO
BLOQUE_NO_ALINEADO:
; comprobar si el bloque es de slo 2 elementos:
	CMP	CX,2
	JE	UNA_PALABRA_NO_ALINEADA ; mejor JE BLOQUE_ALINEADO
NO_ALINEADO: 
        MOVSB           ; mover el primer dato, desde direccin impar
	DEC	CX
BLOQUE_ALINEADO:
; Dividir por dos el tamao del bloque:
	SHR	CX,1
; Trasladar bloque palabra a palabra:
	REP MOVSW
; quedan un ltimo octeto por mover?
	JNC	FINAL
;       S: moverlo:
TERMINA:MOVSB
FINAL:	RET
UNA_PALABRA_NO_ALINEADA:    ; sobra esto si se pone JE BLOQUE_ALINEADO
	MOVSW		    ; porque al ser CX=2 entonces REP MOVSW se
        RET                 ; ejecuta slo una vez (CX<--CX/2)

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
