CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
COMMENT *
===================================================================
=                                                                 =
=                 PROCEDIMIENTO TRASLADA_BLOQUE                   =
=                          Versin 6                              =
===================================================================

Descripcin: Traslada un bloque de cualquier tamao, desde cualquier sitio
hacia cualquier sitio.

Condicin de llamada:
Se pasa por pila, en este orden, la direccin lgica de inicio del bloque a
trasladar, la del destino, y el tamao -doble palabra- del bloque a trasladar.

Condicin de salida: Ninguna

Recursos usados y afectados:
Registro de estado *

; -------------------------------------------------------------------

PARAMETROS	STRUC		; estructura para definir desplazamientos
BP_SALVADO      DW      ?       ; simblicos a los parmetros
RETORNO	DD	?	
TAMANYO_B	DW	?
TAMANYO_B	DW	?
DEST_DESP	DW	?
DEST_SEG	DW	?
INI_DESP	DW	?
INI_SEG	DW	?
		ENDS

TRASLADA_BLOQUE:
	PUSH	BP		; guarda contexto
	MOV	BP,SP
	PUSH	AX		
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	PUSH	DS
	PUSH	DS
; Comprobar si el destino est entre los lmites del bloque:
; Se pasan a fsicas las direcciones lgicas, para compararlas:
; Se pasa la direccin lgica del inicio a direccin fsica...
	MOV	AX,[BP].INI_SEG
	MOV	CX,16
	MUL	CX
	ADD	AX,[BP].INI_DESP
	ADC	DX,0
; ... y se guarda temporalmente en la pila
	PUSX	DX
	PUSH	AX
; Se pasa la direccin lgica del destino a direccin fsica, en DX:AX
	MOV	AX,[BP].DET_SEG
	MUL	CX
	ADD	AX,[BP].DET_DESP
	ADC	DX,0
; Se recupera la direccin fsica del inicio, en CX:BX
	POP	BX
	POP	CX
; Ver si el destino est entre los lmites del bloque
	CMP	CX,DX
	JA 	ASCENDENTE
	JB	VER_SI_SOLAPE
	CMP	BX,AX
	JA	ASCENDENTE
        JE      SALIDA  ; El traslado es quedarse como se est
VER_SI_SOLAPE:                  ; Obtener direcc. fs. fin del bloque(+1)
	ADD	BX,[BP].TAMANYO_B
	ADC	CX,[BP].TAMANYO_A
; Est el destino ms all del final del bloque?
	CMP	CX,DX
	JB	ASCENDENTE
	JA 	ASCENDENTE
	CMP	BX,AX
	JBE	ASCENDENTE
DESCENDENTE:SUB	BX,1		; se empieza desde el final del bloque
	SBB	CX,0
	ADD	AX,[BP].TAMANYO_B	; y desde el final del destino:
	ADC	DX,[BP].TAMANYO_A	; final destino = inicio destino +
        SUB     AX,1                    ;  tamao bloque -1
	SBB	DX,0
; Ahora hay que pasar las direcciones fsicas a direcciones lgicas
        ROR     DX,1    ; clculo del segmento del destino, que se 
        ROR     DX,1    ; pasar al segmento extra
	ROR	DX,1
	ROR	DX,1
	MOV	ES,DX
        MOV     DI,AX   ; como puntero al destino se usar DI
        ROR     CX,1    ; clculo del segmento del bloque, que se 
        ROR     CX,1    ; pasar al segmento de datos
	ROR	CX,1
	ROR	CX,1
	MOV	DS,CX
        MOV     SI,BX   ; como puntero al bloque se usar SI
; (En este punto AX,BX,CX y DX han quedado libres de uso)
        MOV     CX,[BP].TAMANYO_B       ; DX:CX se usar como contador de
	MOV	DX,[BP].TAMANYO_A	; iteraciones para el traslado
	SHR	DX,1			; pero dividido por 2 porque se
        RCR     CX,1                    ; movern palabras
	PUSHF		; se guarda C para saber si queda un octeto suelto
	INC	DX			; para compensar el siguiente DEC 
OTRO_D:	DEC	DX
	MOV	AX,[SI]		; toma palabra
	MOV	ES:[DI],AX		; traslada palabra
	SUB	SI,2			; apuntar a las palabras previas
	JC	SEGMENTA_DESC_INI
	SUB	DI,2
	JC	SEGMENTA_DESC_DEST
ITERAD_D:
        LOOP    OTRO_D          ; queda bloque por trasladar?
	CMP	DX,0
	JNE	OTRO_D		
	POPF				; No, ver si queda un octeto suelto
	JNC	 SALIDA
MUEVE_OCT:	
	MOV	AL,[SI]		;      queda octeto suelto; moverlo
	MOV	ES:[DI],AL
SALIDA:	POP	ES
	POP	DS
	POP	DI
	POP	SI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RETF	6*2
SEGMENTA_DESC_INI:
	MOV	AX,DS
	SUB	AX,1000h
	MOV	DS,AX
	JMP 	SHORT ITERA_D
SEGMENTA_DESC_DEST:
	MOV	AX,ES
	SUB	AX,1000h
	MOV	ES,AX
	JMP 	SHORT ITERA_D
; Aqu se hace el traslado en sentido ascendente (no hay solape crt.)
ASCENDENTE:	
	LDS	SI,DWORD PTR [BP].INI_DESP	; tomar direcciones de
	LES	DI,DWORD PTR [BP].DEST_DESP	; los inicios
	MOV	CX,[BP].TAMANYO_B
	MOV	DX,[BP].TAMANYO_A
	SHR	DX,1
	RCR	CX,1
	PUSHF
	DEC	DX
OTRO_A:	INC	DX
	MOV	AX,[SI]
	MOV	ES:[DI],AX
	ADD	SI,2			; apuntar a las palabras previas
	JC	SEGMENTA_ASCE_INI
	ADD	DI,2
	JC	SEGMENTA_ASCE_DEST
ITERAD_A:	
        LOOP    OTRO_A          ; queda bloque por trasladar?
	CMP	DX,0
	JNE	OTRO_A		
	POPF				; No, ver si queda un octeto suelto
	JNC	 SALIDA
	JC	MUEVE_OCT		;      queda octeto suelto; moverlo
SEGMENTA_ASCE_INI:
	MOV	AX,DS
	ADD	AX,1000h
	MOV	DS,AX
	JMP 	SHORT ITERA_A
SEGMENTA_ASCE_DEST:
	MOV	AX,ES
	ADD	AX,1000h
	MOV	ES,AX
	JMP 	SHORT ITERA_A

ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
