CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
COMMENT *
===================================================================
=                                                                 =
=                       RUTINA  BUSCA_CADENA                      =
=                             Versin 4                           =
=                                                                 =
=================================================================== 

Descripcin: Busca una cadena de hasta 65536 octetos en un bloque de hasta 64
Kilo-octetos. La cadena y el bloque no deben sobrepasar el segmento especificado.

Condicin de llamada:
AX:SI = direccin de la  cadena (seg:desp)
DX:DI = direccin del bloque
BX = tamao de la cadena
CX = tamao del bloque

Condicin de retorno:
Bandera C=0 --> no se ha encontrado la cadena
Bandera C=1 --> se ha encontrado la cadena
BP <-- desplazamiento dentro del bloque a partir de donde se ha encontrado  la cadena
*

BUSCA_CADENA:	
        MOV     DS,AX
        MOV     ES,DX
        MOV     CS:INICIO_CADENA,SI     ; mejor: MOV  DX,SI
        INC     CS:INICIO_CADENA
        SUB     CX,BX
        INC     CX
        CLD
        LODSB
BUSCA_INICIO_CADENA:
        REPNE SCASB
        JNE     NO_ENCONTRADA
        LEA     BP,[DI-1]
        PUSH    CX
        MOV     CX,BX
        LOOP    AVANZA_EN_CADENA
ENCONTRADA:
	POP	CX
        STC
        RET
NO_ENCONTRADA:
        CLC
        RET
AVANZA_EN_CADENA:
        REPE CMPSB
        JE      ENCONTRADA
        POP     CX
        LEA     DI,[BP+1]
        MOV     SI,CS:INICIO_CADENA             ; mejor:  MOV  SI,DX
        JMP SHORT BUSCA_INICIO_CADENA

        EVEN
INICIO_CADENA DW ?


ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
