CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR
COMMENT *
===================================================================
=                                                                 =
=                       RUTINA  BUSCA_CADENA                      =
=                             Versin 5                           =
=                                                                 =
=================================================================== 

Descripcin: Busca una cadena de datos tipo palabra en un bloque de hasta 64
Kilo-octetos. La cadena y el bloque no deben sobrepasar el segmento especificado.

Condicin de llamada:
AX:SI = direccin de la  cadena (seg:desp)
DX:DI = direccin del bloque
BX = tamao de la cadena, en palabras
CX = tamao del bloque, en palabras

Condicin de retorno:
Bandera C=0 --> no se ha encontrado la cadena
Bandera C=1 --> se ha encontrado la cadena
BP <-- desplazamiento dentro del bloque a partir de donde se ha encontrado  la cadena
*

BUSCA_CADENA:	
        MOV     DS,AX
        MOV     ES,DX
        SUB     CX,BX
        INC     CX
        CLD
        LODSW
        MOV     CS:INICIO_CADENA,SI   
BUSCA_INICIO_CADENA:
        REPNE SCASW
        JNE     NO_ENCONTRADA
        LEA     BP,[DI-2]
        PUSH    CX
        MOV     CX,BX
        LOOP    AVANZA_EN_CADENA
ENCONTRADA:
	POP	CX
        STC
        RET
NO_ENCONTRADA:
        CLC
        RET
AVANZA_EN_CADENA:
        REPE CMPSW
        JE      ENCONTRADA
        POP     CX
        LEA     DI,[BP+2]
        MOV     SI,CS:INICIO_CADENA             ; mejor:  MOV  SI,DX
        JMP SHORT BUSCA_INICIO_CADENA

        EVEN
INICIO_CADENA DW ?


ENTRADA ENDP
CODIGO  ENDS
        END ENTRADA
