; Procedimiento para transmitir DX:CX datos octetos de manera
; paralela asncrona, ubicados a partir de la direccin lgica AX:SI
;
PUERTO_A	EQU	60h
PUERTO_C	EQU	62h

CODIGO  SEGMENT
        ASSUME  CS:CODIGO
ENTRADA PROC    FAR

TRANSMITE:MOV	DS,AX
	CLD
	ADD	DX,2		; apunta al puerto C
OTRO_DATO:
	CALL	ESPERA_NO_RECO
	CALL	LANZA_DATO
	CALL	VALIDA
	CALL	ESPERA_RECO
        CALL    MIRA_SI_QUEDAN_DATOS    ; C=1 --> s quedan
	JNZ	OTRO_DATO
	RET
ENTRADA	ENDP

ESPERA_NO_RECO	PROC
; Esperar a que el reconocimiento se inactive:
	IN	AL,DX
	TEST	AL,00000001b
	JZ	ESPERA_NO_RECO
	RET
ESPERA_NO_RECO	ENDP

LANZA_DATO	PROC
; Tomar dato (y apuntar al siguiente):
	CMP	SI,0FFFFh
	JE	SEGMENTAR
TOMA_DATO:
	LODSB
; Emitirlo:
	SUB	DX,2
	OUT	DX,AL
	RET
SEGMENTAR:
	MOV	AX,DS
	ADD	AX,1000h
	MOV	DS,AX
	JMP	SHORT TOMA_DATO
LANZA_DATO	ENDP

VALIDA	PROC
; Validarlo:
	ADD	DX,2
	IN	AL,DX
	AND	AL,11101111b
	OUT	DX,AL
	NOP
	NOP
	NOP
	NOP
	OR	AL,00010000b
	OUT	DX,AL
	RET
VALIDA	ENDP

ESPERA_RECO	PROC
; Esperar impulso de reconocimiento:
	IN	AL,DX
	TEST	AL,00000001b
	JNZ	ESPERA_RECO
	RET
ESPERA_RECO	ENDP

MIRA_SI_QUEDAN_DATOS	PROC
	LOOP	QUEDAN
	CMP	DX,0
	JE	NO_QUEDAN
	DEC	DX
QUEDAN:	STC
	RET
NO_QUEDAN:
	CLC
	RET
MIRA_SI_QUEDAN_DATOS	ENDP

CODIGO  ENDS
        END ENTRADA
